.module animation

.include "cpctelera.h.s"
.include "assets/template.h.s"
.include "assets/sprites.h.s"
.include "man/vecentity.h.s"

.globl cpct_memset_asm


;; Frames a esperar para cambiar de animacion
duracion_reflective_big		=	0
duracion_reflective_small	=	0
duracion_pato 				=	6
duracion_pato_small 		=	0
duracion_player 			=	3
duracion_tempo 				=	10
duracion_fantasma 			=	6

animations_array_player:
	.dw nullptr 
	.dw anim_taco_alto  ;; ((orientation * 2) -1) * 2(es una palabra)
	.dw anim_taco_bajo		
	.dw anim_taco_alto		
	.dw anim_taco_bajo		

animations_array_pato:
	.dw nullptr
	.dw anim_pato
	.dw anim_pato
	.dw anim_pato
	.dw anim_pato

animations_array_pato_small:
	.dw nullptr
	.dw anim_pato_small
	.dw anim_pato_small
	.dw anim_pato_small
	.dw anim_pato_small

animations_array_tempo:
	.dw nullptr
	.dw anim_tempo
	.dw anim_tempo
	.dw anim_tempo
	.dw anim_tempo

animations_array_reflective_big:
	.dw nullptr
	.dw anim_reflective_big
	.dw anim_reflective_big
	.dw anim_reflective_big
	.dw anim_reflective_big

animations_array_reflective_small:
	.dw nullptr
	.dw anim_reflective_small_left
	.dw anim_reflective_small_right
	.dw anim_reflective_small_right
	.dw anim_reflective_small_left

animations_array_fantasma_opaco:
	.dw nullptr
	.dw anim_fantasma_opaco
	.dw anim_fantasma_opaco
	.dw anim_fantasma_opaco
	.dw anim_fantasma_opaco

animations_array_fantasma_transparente:
	.dw nullptr
	.dw anim_fantasma_transparente
	.dw anim_fantasma_transparente
	.dw anim_fantasma_transparente
	.dw anim_fantasma_transparente

;; INPUT IX= entity
;; Destroy A
man_animation_setAnimTimeout::
	ld a, e_type(ix)
    and #t_player
    jp z, noesplayer
esplayer:
	ld e_frames_animation(ix), #duracion_player
	ret
noesplayer:

	ld a, #t_enemy|#t_bala_enemy
    and e_type(ix)
    jp z, noesenemy
esenemy:
	ld e_frames_animation(ix), #duracion_pato
	ret
noesenemy:

	ret

;; INPUT B= Anim orientation
;; 		IX= entity
;; OUTPUT HL=Pointer to animation
man_animation_getAnimHL::
	ld a, e_enemy_type(ix)
	cp #et_reflective_pato_big
	jr z, es_reflective_big

	cp #et_reflective_pato_small
	jr z, es_reflective_small

	ld a, e_type(ix)
    and #t_player
    jp z, no_es_player
es_player:
	ld hl, #animations_array_player
	;; inicializa contador
	ld e_frames_animation(ix), #duracion_player
	jp asigna_animacion
no_es_player:

	ld a, #t_enemy|#t_bala_enemy
    and e_type(ix)
    jp z, no_es_enemy
es_enemy: ;; ahora qué tipo de enemy
	ld a, e_enemy_type(ix)
    and #et_pato
    jp z, no_es_pato
es_pato:
	ld hl, #animations_array_pato
	;; inicializa contador
	ld e_frames_animation(ix), #duracion_pato
	jp asigna_animacion

no_es_pato:
	ld a, e_enemy_type(ix)
    and #et_pato_small
    jp z, no_es_pato_small
es_pato_small:
	ld hl, #animations_array_pato_small
	;; inicializa contador
	ld e_frames_animation(ix), #duracion_pato_small
	jp asigna_animacion
no_es_pato_small:
	ld a, e_enemy_type(ix)
    and #et_tempo
    jp z, no_es_tempo

es_tempo:
	ld hl, #animations_array_tempo
	;; inicializa contador
	ld e_frames_animation(ix), #duracion_tempo
	jp asigna_animacion

no_es_tempo:
	ld a, e_enemy_type(ix)
    and #et_fantasma
    jp z, no_es_fantasma

es_fantasma:
	es_opaco:
		ld a, e_type(ix)
		and #t_invisible
		jr nz, es_transparente
		ld hl, #animations_array_fantasma_opaco
		;; inicializa contador
		ld e_frames_animation(ix), #duracion_fantasma
		jp asigna_animacion

	es_transparente:
		ld hl, #animations_array_fantasma_transparente
		;; inicializa contador
		ld e_frames_animation(ix), #duracion_fantasma
		jp asigna_animacion

no_es_fantasma:


	es_reflective_big:
	ld hl, #animations_array_reflective_big
	ld e_frames_animation(ix), #duracion_reflective_big
	jp asigna_animacion

	es_reflective_small:
	ld hl, #animations_array_reflective_small
	ld e_frames_animation(ix), #duracion_reflective_small
	jp asigna_animacion


	ret


no_es_enemy:
	;; Death animation t_default, no collision
	ret

asigna_animacion:
	ld a, b
	add a ;; a*2

	;; [45][24] + [--][32] == [45][56]
	add_hl_a

	ld a, (hl)
	inc hl 
	ld h, (hl)
	ld l, a 

	ret

anim_taco_alto::
	.dw taco_alto_sprite1
	.dw taco_alto_sprite2
	.dw nullptr
	.dw anim_taco_alto	

anim_taco_bajo::
	.dw taco_bajo_sprite1
	.dw taco_bajo_sprite2
	.dw taco_bajo_sprite3
	.dw taco_bajo_sprite4	
	.dw nullptr
	.dw anim_taco_bajo	
	
anim_pato::
	.dw pato_sprite1
	.dw pato_sprite1
	.dw pato_sprite2
	.dw pato_sprite3
	.dw nullptr
	.dw anim_pato	

anim_pato_small::
	.dw pato_small1
	.dw pato_small1
	.dw pato_small2
	.dw pato_small3
	.dw nullptr
	.dw anim_pato_small

anim_tempo::
	.dw tempo_sprite1
	.dw tempo_sprite2
	.dw tempo_sprite3
	.dw tempo_sprite4
	.dw nullptr
	.dw anim_tempo

anim_reflective_big::
	.dw _g_reflective_pato_big_1
	.dw _g_reflective_pato_big_2
	.dw _g_reflective_pato_big_3
	.dw _g_reflective_pato_big_4
	.dw _g_reflective_pato_big_3
	.dw _g_reflective_pato_big_2
	.dw nullptr
	.dw anim_reflective_big

anim_reflective_small_right::
	.dw _g_reflective_pato_small_right_1
	.dw _g_reflective_pato_small_right_1
	.dw _g_reflective_pato_small_right_2
	.dw nullptr
	.dw anim_reflective_small_right

anim_reflective_small_left::
	.dw _g_reflective_pato_small_left_1
	.dw _g_reflective_pato_small_left_1
	.dw _g_reflective_pato_small_left_2
	.dw nullptr
	.dw anim_reflective_small_left

anim_tempo_cargando1::
	.dw tempo_sprite1
	.dw nullptr
	.dw anim_tempo_cargando1

anim_tempo_cargando2::
	.dw tempo_sprite4
	.dw nullptr
	.dw anim_tempo_cargando2

anim_fantasma_opaco::
	.dw fantasma_sprite_opaco1
	.dw fantasma_sprite_opaco2
	.dw fantasma_sprite_opaco1
	.dw fantasma_sprite_opaco2
	.dw nullptr
	.dw anim_fantasma_opaco

anim_fantasma_transparente::
	.dw fantasma_sprite_transparente1
	.dw fantasma_sprite_transparente2
	.dw fantasma_sprite_transparente1
	.dw fantasma_sprite_transparente2
	.dw nullptr
	.dw anim_fantasma_transparente
	
anim_popping::
	.dw _g_popping_sprite_1  
	.dw _g_popping_sprite_1  
	.dw _g_popping_sprite_1  
	.dw _g_popping_sprite_1  
	.dw _g_popping_sprite_14  
	.dw _g_popping_sprite_14  
	.dw _g_popping_sprite_14  
	.dw _g_popping_sprite_14  
	.dw _g_popping_sprite_2  
	.dw _g_popping_sprite_2  
	.dw _g_popping_sprite_2  
	.dw _g_popping_sprite_2  
	.dw _g_popping_sprite_12  
	.dw _g_popping_sprite_12  
	.dw _g_popping_sprite_12  
	.dw _g_popping_sprite_12  
	.dw _g_popping_sprite_34  
	.dw _g_popping_sprite_34  
	.dw _g_popping_sprite_34  
	.dw _g_popping_sprite_34  
	.dw _g_popping_sprite_3  
	.dw _g_popping_sprite_3  
    .dw _g_popping_sprite_3  
	.dw _g_popping_sprite_3 
	.dw _g_popping_sprite_3  
	.dw _g_popping_sprite_3  
    .dw _g_popping_sprite_3  
	.dw _g_popping_sprite_3  
    .dw nullptr


num_animation:: .db 0
_animation_last_ptr: .dw animation_ptr_array
animation_ptr_array:
    .ds 2*max_entities

;; DESTROY: AF, BC, DE, HL
;; RETURNS: HL: Pointer to start of the pointer array
man_animation_init::
	;; Pointer to array End
	call man_animation_getArray_HL
	ld (_animation_last_ptr), hl

	ex de, hl
	xor a
	ld bc, #max_entities
    call cpct_memset_asm

	xor a
	ld (num_animation), a 

	ret

;; RETURNS HL: Pointer to the array of pointers
man_animation_getArray_HL::
	ld hl, #animation_ptr_array
	ret

;; Llama al limpiador genérico
man_animation_clean::
	ld hl, #_animation_last_ptr
	ex de, hl
	ld hl, #num_animation
	ld ix, #animation_ptr_array
	call man_vecentity_clean
	ret

;; INPUT: IX: Pointer to the new entity to be added
;; Implements generic function
man_animation_add::
	ld hl, #_animation_last_ptr
	ex de, hl
	ld hl, #num_animation
	call man_vecentity_add
	ret


.globl _g_popping_sprite_1
.globl _g_popping_sprite_2
.globl _g_popping_sprite_3
.globl _g_popping_sprite_14
.globl _g_popping_sprite_12
.globl _g_popping_sprite_34