.module collision

.include "cpctelera.h.s"
.include "assets/template.h.s"
.include "man/vecentity.h.s"

.globl cpct_memset_asm


num_collision:: .db 0
_collision_last_ptr:: .dw collision_ptr_array
collision_ptr_array::
    .ds 2*max_entities

;; DESTROY: AF, BC, DE, HL
;; RETURNS: HL: Pointer to start of the pointer array
man_collision_init::

	;; Pointer to array End
	call man_collision_getArray_HL
	ld (_collision_last_ptr), hl

	ex de, hl
	xor a
	ld bc, #max_entities
    call cpct_memset_asm

	xor a
	ld (num_collision), a 

	ret

;; RETURNS HL: Pointer to the array of pointers
man_collision_getArray_HL::
	ld hl, #collision_ptr_array
	ret

;; INPUT: IX: Pointer to the new entity to be added
;; Implements generic function
man_collision_add::
	ld hl, #_collision_last_ptr
	ex de, hl
	ld hl, #num_collision
	call man_vecentity_add
	ret

;; Llama al limpiador genérico
man_collision_clean::
	ld hl, #_collision_last_ptr
	ex de, hl
	ld hl, #num_collision
	ld ix, #collision_ptr_array
	call man_vecentity_clean
	ret

