.module lvl

.include "cpctelera.h.s"
.include "man/game.h.s"
.include "man/lvl.h.s"
.include "man/entity.h.s"
.include "man/collision.h.s"
.include "man/animation.h.s"
.include "man/vecentity.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "sys/ai.h.s"
.include "sys/syscol.h.s"
.include "sys/sysanimation.h.s"
.include "assets/sprites.h.s"
.include "assets/template.h.s"
.include "man/music.h.s"

.globl cpct_drawStringM0_asm
.globl cpct_getScreenPtr_asm

waiting_lvl_time = 120

oleada_counter_time:
    .db #01

oleada_end:: ;; 00 next oleada
    .db #01

entidad_oleada::
    .dw #0000

bucle_oleada::
    .dw #0000

mascara_intervalo_oleada:
    .db #03

max_enemies_on_screen::
    .db #00

reflective_patos::
    .db #00

man_lvl_init::
	call paint_lvl_name
	call man_game_init_lvl
	ret


;; Paints the transition between lvls (in c000)
paint_lvl_name::

    disable_music

    ld l, #video_mem_page_shifted
    call cpct_setVideoMemoryPage_asm

	call clear_screen_black
	ld hl, #main_palette
    ld de, #4
    call cpct_setPalette_asm
	cpctm_setBorder_asm HW_BLACK
	

    ld de, #screen_start
    ld c, #screen_width/2 - 3
    ld b, #screen_height/2 - 8
    call cpct_getScreenPtr_asm
    ex de, hl 
	call draw_lvl_chars

	ld de, #screen_start
    ld c, #screen_width/2 + 4
    ld b, #screen_height/2 - 8
    call cpct_getScreenPtr_asm
    ex de, hl

	draw_lvl_numbers_twice

	ld de, #screen_start
    ld c, #screen_width/2 - 7
    ld b, #screen_height/2 + 12
    call cpct_getScreenPtr_asm
    ex de, hl 
	call draw_lives_chars

	ld de, #screen_start
    ld c, #screen_width/2 + 7
    ld b, #screen_height/2 + 13
    call cpct_getScreenPtr_asm
    ex de, hl

	draw_lives_numbers_twice


	ld d, #waiting_lvl_time
	call wait_halts
	ret
	

;;Sets all video memory to 0F
clear_screen_black:
	ld de, #0xC000
	ld a, #0x0F ; a = 0
	ld bc, #0x4000
	call cpct_memset_asm

	ret

;; INPUT: HL: conjunto de entidades a lanzar (oleada_1)
;;        A: intervalo entre estas  (mascara)
lanza_oleada::
    ld ix, #mascara_intervalo_oleada
    ld (ix), a 
    ld ix, #bucle_oleada
    ld (ix), l
    inc ix 
    ld (ix), h
    ld ix, #entidad_oleada
    ld c, (hl)
    ld (ix), c
    inc hl 
    inc ix 
    ld c, (hl)
    ld (ix), c
    ld a, #0x01
    ld hl, #oleada_counter_time
    ld (hl), a
    ld hl, #oleada_end
    ld (hl), a
    ret

;; checks if there is no more oleada or if 
;; no INPUT
itera_oleada_surv::

    ld hl, #level_enemies 
    ld a, (max_enemies_on_screen)
    cp (hl)
    ret c ;; Lets not saturate the z80

    jp decrementa_oleada_counter_surv

    lanza_enemigo_surv:
    call initialize_oleada_counter

    jp select_entity_surv
    selected_entity_surv:
    ld__ixh_b
    ld__ixl_c ;; ix = hl 

    call choose_corner
	;call man_entity_create
    call man_create_popping

    ret

;; checks if there is no more oleada or if 
;; no INPUT
itera_oleada::

    ld hl, #oleada_end 
    xor a 
    cp (hl)
    ret z

    ld hl, #level_enemies 
    ld a, (max_enemies_on_screen)
    cp (hl)
    ret c ;; Lets not saturate the z80

    jp decrementa_oleada_counter

    lanza_enemigo:
    call initialize_oleada_counter

    jp select_entity
    selected_entity:
    ld__ixh_b
    ld__ixl_c ;; ix = hl 

    call choose_corner
	;call man_entity_create
    call man_create_popping

    ret

choose_corner:
    push ix 
    push hl 
    
    ld a, e_enemy_type(ix)
    cp #et_tempo
    jr nz, no_es_tempo
    ld e_x0(ix), #screen_width - 8
	ld e_y0(ix), #screen_height - 32
    pop hl 
    pop ix
    ret 

    no_es_tempo:

    ld a, e_enemy_type(ix)
    cp #et_reflective_pato_big
    jr nz, no_es_reflector
    ld e_x0(ix), #36 
	ld e_y0(ix), #20
    ld hl, #reflective_patos
    ld (hl), #0x01
    pop hl 
    pop ix
    ret

    no_es_reflector:
    ld a, #0x03
    call get_random
    pop hl 
    pop ix

    cp #03 
    jr z, create_lu ;; left-up

    cp #02 
    jr z, create_ld

    cp #01 
    jr z, create_ru

    cp #00
    jr z, create_rd

create_ru_pato_big:
	ld e_x0(ix), #screen_width - 8
	ld e_y0(ix), #18
    ret

create_rd_pato_big:
    ld e_x0(ix), #screen_width - 8
	ld e_y0(ix), #screen_height - 16
    ret

create_lu:
	ld e_x0(ix), #4 
	ld e_y0(ix), #18
    ret

create_ld:
	ld e_x0(ix), #4 
	ld e_y0(ix), #screen_height-16
    ret

create_ru:
	ld e_x0(ix), #screen_width - 5
	ld e_y0(ix), #18
    ret

create_rd:
	ld e_x0(ix), #screen_width - 5
	ld e_y0(ix), #screen_height - 16
    ret

decrementa_oleada_counter:
    xor a 
    ld hl, #oleada_counter_time
    cp (hl)
    jp z, lanza_enemigo
    dec (hl)
    ret 

decrementa_oleada_counter_surv:
    xor a 
    ld hl, #oleada_counter_time
    cp (hl)
    jp z, lanza_enemigo_surv
    dec (hl)
    ret 


initialize_oleada_counter:
    ld a, (mascara_intervalo_oleada)
    call get_random
    add #5
    ld hl, #oleada_counter_time
    ld (hl), a
    ret

select_entity_surv:

    ld a, #0x0F
    call get_random
    cp #00
    jr nz, no_reflector
    ld hl, #reflective_patos
    cp (hl) 
    jr z, no_hay_mas
    inc a 
    no_hay_mas:
    no_reflector:
    ld hl, #oleada_surv
    loop_surviv_entity:
    ld c, (hl)   
    inc hl 
    ld b, (hl)  
    inc hl   

    cp #0 
    jr z, out_loop_surviv_entity
    dec a 
    jr loop_surviv_entity

    out_loop_surviv_entity:
    ld l, c         
    ld h, b         
    
    jp selected_entity_surv ;; Si es 0 el counter



;; Checks if its the end of loop and chooses the animation
;; RETURN: BC: the entity
select_entity:
    ld hl, #entidad_oleada
    
    ld e, (hl) ;; DE = siguiente paso de la oleada
    inc hl 
    ld d, (hl)
    ex de, hl

    continua_oleada:
    ld c, (hl)   
    inc hl 
    ld b, (hl)  ;; BC = Siguiente enemigo
    inc hl      ;; HL += 2, siguiente paso de oleada
    
    ld a, c     ;; Si es nullptr se resetea
    or b 
    jr z, fin_oleada

    ld ix, #entidad_oleada
    ld (ix), l ;; Guarda la siguiente posicion en la entidad
    ld 1(ix), h 
    
    ld l, c         
    ld h, b         
    
    jp selected_entity ;; Si es 0 el counter


fin_oleada:
    jp siguiente_oleada
    ;;ld a, (hl) 
    ;;inc hl     ;; HL = (HL), de esta forma se vuelve al principio de la oleada
    ;;ld h, (hl)
    ;;ld l, a 
    ;;jr continua_oleada

siguiente_oleada::
    ld ix, #bucle_oleada
    ld l, (ix)
    ld h, 1(ix)

    inc hl 
    inc hl 

	ld e, (hl) ;; DE = siguiente paso de la oleada
    inc hl 
    ld d, (hl)

	ld a, e 
   	or d 
	jr nz, hay_mas ;; nullptr
    
    xor a 
    ld hl, #oleada_end
    ld (hl), a 
    ret 

    hay_mas:
    dec hl 
    ld (ix), l
    ld 1(ix), h

	ld hl, #entidad_oleada ;; theres another one
	ld (hl), e
	inc hl 
	ld (hl), d 
    ld a, #wait_time_between_oleadas
    ld hl, #oleada_counter_time
    ld (hl), a
    ret

oleada_1::
    .dw oleada_1_1
    .dw oleada_1_2
    .dw oleada_1_3
    .dw nullptr

oleada_1_1:
	.dw pato_small_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
	.dw nullptr

oleada_1_2:
	.dw pato_small_entidad
    .dw pato_entidad
    .dw pato_small_entidad
    .dw pato_entidad
    .dw pato_small_entidad
	.dw nullptr

oleada_1_3:
    .dw pato_entidad
    .dw pato_entidad
    .dw pato_entidad
    .dw pato_entidad
    .dw pato_entidad
    .dw pato_entidad
    .dw nullptr


oleada_2::
    .dw oleada_2_1
    .dw oleada_2_2
    .dw oleada_2_3
    .dw oleada_2_4
    .dw nullptr

oleada_2_1:
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw nullptr

oleada_2_2:
	.dw fantasma_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
	.dw nullptr

oleada_2_3:
	.dw pato_entidad
    .dw pato_small_entidad
    .dw pato_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
	.dw fantasma_entidad
    .dw nullptr

oleada_2_4:
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw nullptr

oleada_3::
    .dw oleada_3_1
    .dw oleada_3_2
    .dw oleada_3_3
    .dw nullptr

oleada_3_1:
    .dw tanque_entidad
    .dw tanque_entidad
    .dw nullptr

oleada_3_2:
    .dw pato_entidad
    .dw pato_entidad
    .dw pato_small_entidad
	.dw nullptr

oleada_3_3:
	.dw pato_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw tanque_entidad
    .dw pato_small_entidad
    .dw pato_entidad
	.dw fantasma_entidad
    .dw nullptr

oleada_4::
    .dw oleada_4_1
    .dw oleada_4_2
    .dw oleada_2_3
    .dw nullptr

oleada_4_1:
    .dw tempo_entidad
    .dw tempo_entidad
    .dw tempo_entidad
    .dw nullptr

oleada_4_2:
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw pato_entidad
    .dw tempo_entidad
    .dw nullptr

oleada_5::
    .dw oleada_5_2
    .dw oleada_3_3
    .dw nullptr

oleada_5_2:
    .dw reflective_pato_big_entity
    .dw pato_small_entidad
    .dw fantasma_entidad
    .dw nullptr


oleada_6::
    .dw oleada_6_1
    .dw oleada_6_2
    .dw oleada_6_3
    .dw oleada_6_4
    .dw nullptr

oleada_6_1:
    .dw reflective_pato_big_entity
    .dw tempo_entidad
    .dw tempo_entidad
    .dw tempo_entidad
    .dw tempo_entidad
    .dw tempo_entidad
    .dw tempo_entidad
    .dw nullptr

oleada_6_2:
    .dw tanque_entidad
    .dw tanque_entidad
    .dw nullptr

oleada_6_3:
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw nullptr

oleada_6_4:
    .dw pato_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw tempo_entidad
    .dw tanque_entidad
    .dw pato_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw pato_entidad
    .dw fantasma_entidad
    .dw pato_small_entidad
    .dw nullptr

oleada_surv:
    .dw reflective_pato_big_entity
    .dw pato_small_entidad
    .dw pato_entidad
    .dw fantasma_entidad
    .dw tempo_entidad
    .dw tanque_entidad
    .dw pato_entidad
    .dw pato_small_entidad

    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw pato_small_entidad
    .dw fantasma_entidad
    .dw fantasma_entidad
    .dw tempo_entidad
    .dw pato_entidad
