.module music

.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_isKeyPressed_asm
.globl cpct_akp_stop_asm
.globl music_playing
.globl music_muted

.globl _music_track_1
.globl _music_track_2

.macro enable_music
    ld a, #1
    ld (music_playing), a
.endm

.macro disable_music
    call cpct_akp_stop_asm
    ld a, #0
    ld (music_playing), a
.endm

.macro check_mute_music

	ld hl, #Key_M
	call cpct_isKeyPressed_asm
    jr z, end_mute_check

    mute_pressed:

    ld a, (music_muted)
    cp #1
    jr z, music_was_muted
    disable_music
    ld hl, #music_muted
    ld (hl), #1
    jr end_mute_check
    music_was_muted:
    enable_music
    ld hl, #music_muted
    ld (hl), #0
    end_mute_check:
.endm

.macro play_music_cycle_with_check
    ld a, (music_playing)
    cp #0
    jr z, end_play_music_cycle_with_check
    
    call cpct_akp_musicPlay_asm
    
    end_play_music_cycle_with_check:
.endm