.module vecentity

.include "cpctelera.h.s"
.include "assets/template.h.s"
.include "man/collision.h.s"
.include "man/animation.h.s"
.include "man/mania.h.s"

.globl cpct_memset_asm

;; Gestor común para los vectores de entidades
last_ptr:
	.dw #0x0000
;; Gestor común para el tamaño de los vectores de entidades
num_array:
	.dw #0x0000

;; INPUT: HL: local ptr
;; RETURNS: HL: direction to the real address
;; DESTROY: DE, HL
;; guardo en una direccion local la direccion a otra que se querrá modificar
man_vecentity_getptr:
	ld e, (hl)
	inc hl 
	ld d, (hl)
	ex de, hl
	ret

;; INPUT: HL: local ptr
;;		  DE: value to introduce
;; DESTROY: DE, HL
;; guardo un valor en el puntero que puntera la dirección local
man_vecentity_setptr:

	ld (hl), e
	inc hl 
	ld (hl), d

	ret


;;INPUT: ix entity to be deleted
;; 		 hl last_ptr
;;		 de num_size_array
;;will copy ((_collision_elem_ptr) - entity_size) into (ix)
;;then (_collision_elem_ptr) = (_collision_elem_ptr) - entity_size
;;then (_num_entities)--
man_vecentity_delete:

	ld hl, (last_ptr)
	call man_vecentity_getptr

	;;ld hl, (_collision_last_ptr)
	;;hl = _collision_elem_ptr - entity_size
	ld bc, #2 ;; size_entity, pero son vectores de punteros en teoria
	or a ;;reset carry flag so sbc acts like a normal substraction
	sbc hl, bc
	push hl
	;;de = ix
	ld__d_ixh
	ld__e_ixl
	;; copy (hl) into (de) entity_size times
	ldir
	;; _collision_elem_ptr = _collision_elem_ptr - entity_size 

	;; Poner a 0 la última posición 
	xor a 
	dec hl 
	ld (hl), a
	dec hl
	ld (hl), a

	pop hl
	ex de, hl ;; en hl el valor del ptr del ptr que tiene que tener y en dl el ptr
	ld hl, (last_ptr)
	call man_vecentity_setptr
	;; (_num_entities)--
	;;;;;;ld hl, #num_collision
	

	ld hl, (num_array)
	dec (hl)
	ret


;; INPUT: Tenemos en ix la entidad.
;; Entity will be deleted if has flag to_be_deleted
man_vecentity_clean_if:
	ld a, #t_toBeKilled
	;;de = ix
	ld__d_ixh
	ld__e_ixl
	ex de, hl
	;;	 hl, #e_type ;; Aunque es 0
	ld e, (hl)
	inc hl
	ld d, (hl)
	ex de, hl

	and (hl)
	ret z ;; Si el and vale 0 que implicaría que no es una entidad a borrar, saldría de la función.
	call man_vecentity_delete
	ret

;; INPUT: HL: num_size_array (num_collision)
;;		  IX: ptr_array (collision_ptr_array)
;;		  DE: last_ptr (_collision_last_ptr)
;;;; Deletes all vecentity marked with to_be_killed flag. Cannot use forall because array's size changes with
;;;; each iteration
man_vecentity_clean::
	ld (num_array), hl
	ld b, (hl)
	inc b
	ex de, hl
	ld (last_ptr), hl
	ex de, hl	
	ld de, #2 ;; entity size

	man_vecentity_clean_loop:
		dec b
		ret z
		ld a, (hl)
		ex af, af'
		exx
		call man_vecentity_clean_if
		exx
		ex af, af'
		cp (hl)
		jr nz, man_vecentity_clean_loop ;; si se ha borrado
		add ix, de
		jr man_vecentity_clean_loop

;; Llama a los otros managers para hacer limpieza
man_vecentity_clean_all::
	call man_collision_clean
	call man_animation_clean
	call man_ia_clean

	ret


;; INPUT: HL: num_size_array (num_collision)
;;		  IX: Pointer to the new entity to be added
;;		  DE: last_ptr (_collision_last_ptr)
;;;; Adds new entity
man_vecentity_add::
	;; First free element in ptr
	ld (num_array), hl 
	ex de, hl
	ld (last_ptr), hl
	call man_vecentity_getptr
	ld__a_ixl
	ld (hl), a 
	inc hl 
	ld__a_ixh
	ld (hl), a 

	;; Move collision ptr +2 bytes to point to the next available element
	inc hl 
	ex de, hl
	ld hl, (last_ptr)
	call man_vecentity_setptr
	;;ld (_collision_last_ptr), hl

	ld hl, (num_array) 
	;;ld hl, #num_collision
	inc (hl)

	ret