.module ai

.include "cpctelera.h.s"
.include "sys/ai.h.s"
.include "man/animation.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "man/mania.h.s"
.include "assets/template.h.s"
.include "assets/sprites.h.s"
.include "sys/syscol.h.s"

.globl cpct_getRandom_mxor_u8_asm

reflective_big_pato_leftmost_x = 21
reflective_big_pato_rightmost_x = 51
reflective_big_pato_invulnerable_cycles = 3
reflective_big_pato_update_vy_vertical_default = 5

reflective_big_pato_old_vx:
    .db 0

reflective_big_pato_update_vy_cycles:
    .db reflective_big_pato_update_vy_vertical_default

big_pato_screen_middle = 36

small_pato_update_vx_cycle:
    .db #00
counter_fantasma_estado:
    .db #00

counter_fantasma_movement:
    .db #00

small_pato_update_vx_max_cycles = 10
;;                          xxyy
fast_pato_return_up_x_y = 0x26A7
fast_pato_imback_x_y = 0x2511

counter_tempo::
    .db #00

;; DESTROY: HL
sys_ai_init::
    call man_ia_getArray_HL
    ld (_entity_array_prt), hl
    ret

;;Updates ai behaviour for all entites with ai component
sys_ai_update::
    _entity_array_prt = .+1
    ld hl, #0x0000

loop:
    ;;Get pointer to next entity in DE
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl          ;; HL += 2 (Next pointer)

    ;; si DE = null (final), fuera del bucle grande, se han recorrido todos los ptr1 (y todos los ptr2 con cada uno)
    ld a, e 
    or d  
    ret z

    ;; IX = DE
    ld__ixl_e
    ld__ixh_d
    exx
    call sys_ai_update_entity ;; Calcula el comportamiento de la ia
    exx
    jr loop
    
    ret

;;INPUT :  IX entity
;; Will call the appropiate ai behaviour. Said behaviour has to be defined as a pointer to a function in the entity
;; (e_ai_behaviour_l and e_ai_behaviour_h)
sys_ai_update_entity:
    ld h, e_ai_behaviour_h(ix)
    ld l, e_ai_behaviour_l(ix)
    ld bc, #end_ai_update
    push bc
    jp (hl)
    end_ai_update:
    ret


;; INPUR : IX entity
behaviour_muerto_por_bala::

    ld l, e_animated_l(ix)
    ld h, e_animated_h(ix)
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl          

    ld a, e 
    or d 
    jr z, mata_entidad

    anima:

    ld e_animated_l(ix), l 
    ld e_animated_h(ix), h 
    
    ld e_sprite_l(ix), e 
    ld e_sprite_h(ix), d 

    ret

    mata_entidad:
    ld hl, #level_enemies ;; Decrementar el counter del nivel
	dec (hl)
    
    ld a, e_type(ix)
    or #t_toBeKilled
    ld e_type(ix), a
    ret

;; INPUR : IX entity
behaviour_popping::

    ld l, e_animated_l(ix)
    ld h, e_animated_h(ix)
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl          

    ld a, e 
    or d 
    jr z, crea_entidad

    animapopping:

    ld e_animated_l(ix), l 
    ld e_animated_h(ix), h 
    
    ld e_sprite_l(ix), e 
    ld e_sprite_h(ix), d 

    ret

    crea_entidad:

    ld a, e_type(ix)
    or #t_toBeKilled
    ld e_type(ix), a

    ld l, e_enemy_type(ix) ;; entity to create ix
    ld h, e_estado_ia(ix)
    
    push hl 
    inc hl 
	inc hl 
	ld a, e_x0(ix)
	ld (hl), a 
	inc hl 
    ld (hl), a 
	inc hl 
    ld (hl), a 
	inc hl 
	ld a, e_y0(ix)
	ld (hl), a
    inc hl 
    ld (hl), a 
	inc hl 
    ld (hl), a 

    pop hl


    call man_entity_create_save_ix
    
    ret

;;INPUT : IX entity
behaviour_tempo::
        ld a, e_estado_ia(ix)
        sub #default_ai_state_tempo
        jr nz, fase_dos
    inicio:
        ld a, e_x0(ix)
        
        sub #screen_width - #8
        jr z, pared_d
    
        ld a, e_y0(ix)
        sub #screen_height - 32
        jr z, pared_v
    
        ld e_vx(ix), #1
        ld e_vy(ix), #1
        ret
    pared_d:
        ld a, e_y0(ix)
        sub #screen_height - #32
        jp z, cargando1_init
    
        ld e_vx(ix), #0
        ld e_vy(ix), #1
        ret
    pared_v:
        ld a, e_x0(ix)
        
        sub #screen_width - #8
        jp z, cargando1_init
    
        ld e_vx(ix), #1
        ld e_vy(ix), #0
        ret
    hechizo1:
        ld e_estado_ia(ix), #2
        
        ld hl, #hot_palette
        ld de, #4
        call cpct_setPalette_asm
    
        ld hl, #speed_of_game
        ld (hl), #speed_fast
        ld e_vx(ix), #-1
        ld e_vy(ix), #-1
        ld bc, #anim_tempo
        call assign_anim
        ret
    
    fase_dos:
        ld a, e_estado_ia(ix)
        sub #2 
        jr nz, cargando1
    
        ld a, e_x0(ix)
        
        cp #8
        jr c, pared_d2
    
        ld a, e_y0(ix)
        cp #32
        jr c, pared_v2
    
        ld e_vx(ix), #-1
        ld e_vy(ix), #-1
        ret
    pared_d2::
        ld a, e_y0(ix)
        cp #32
        jr c, cargando2_init
    
        ld e_vx(ix), #0
        ld e_vy(ix), #-1
        ret
    pared_v2:
        ld a, e_x0(ix)
        
        sub #8
        jr z, cargando2_init
    
        ld e_vx(ix), #-1
        ld e_vy(ix), #0
        ret
    hechizo2:
        ld hl, #cold_palette
        ld de, #4
        call cpct_setPalette_asm
    
        ld e_estado_ia(ix), #default_ai_state_tempo
        ld hl, #speed_of_game
        ld (hl), #speed_slow
        ld e_vx(ix), #1
        ld e_vy(ix), #1
        ld bc, #anim_tempo
        call assign_anim
        ret
    cargando1_init:
        ld bc, #anim_tempo_cargando1
        call assign_anim
        ld bc, #tempo_sprite1
        call assign_sprite
        ld hl, #counter_tempo
        ld (hl), #tempo_charge_time_slow
        ld e_estado_ia(ix), #3
        ld e_vx(ix), #0
        ld e_vy(ix), #0
    cargando1:
        ld a, e_estado_ia(ix)
        sub #3 
        jr nz, cargando2
    
        ld hl, #counter_tempo
        dec (hl)
        jp z, hechizo1
        ret
    cargando2_init:
        ld bc, #anim_tempo_cargando2
        call assign_anim
        ld bc, #tempo_sprite4
        call assign_sprite
        ld hl, #counter_tempo
        ld (hl), #tempo_charge_time_fast
        ld e_estado_ia(ix), #4
        ld e_vx(ix), #0
        ld e_vy(ix), #0
    
    cargando2:
    
        ld hl, #counter_tempo
        dec (hl)
        jr z, hechizo2
        ret

;; Mueve el fantasma hacia el personaje (damos por hecho que es el primero siempre)
;; INPUT: IX el fantasma, B el valor a reiniciar
;; IY el player
;; DESTROY IY, HL, BC
mueve_fantasma:
    ld hl, #counter_fantasma_movement
    dec (hl)
    jp nz, no_se_mueve

    ld iy, #_entity_array
    ld a, e_x0(iy) ;; taco
    sub e_x0(ix) ;; taco - fantasma
    
    jr nc, mayor_o_igualx
menorx:
    ld e_vx(ix), #-1
    jr calcula_y 
mayor_o_igualx:
    jr z, igualx 
    ld e_vx(ix), #1
    jr calcula_y
igualx:
    ld e_vx(ix), #0
    jr calcula_y
calcula_y:

    ld a, e_y0(iy) 
    sub e_y0(ix) 
    jr nc, mayor_o_igualy
menory:
    ld e_vy(ix), #-1
    jr endif 
mayor_o_igualy:
    jr z, igualy 
    ld e_vy(ix), #1
    jr endif
igualy:
    ld e_vy(ix), #0
    jr endif

endif:
    ld (hl), b
ret

no_se_mueve:
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ret


;; Reset counters
reset_fantasma_estado_normal:
    ld hl, #counter_fantasma_estado
    ld (hl), #tiempo_charge_time_normal
    ret

reset_fantasma_movement_normal:
    ld hl, #counter_fantasma_movement
    ld (hl), #tiempo_movement_time_normal
    ret

reset_fantasma_estado_transparente:
    ld hl, #counter_fantasma_estado
    ld (hl), #tiempo_charge_time_transparente
    ret

reset_fantasma_movement_transparente:
    ld hl, #counter_fantasma_movement
    ld (hl), #tiempo_movement_time_transparente
    ret

;; INPUT: IX: entity
;; add the invisible type
change_enemy_type_inv:
    ld e_type(ix), #t_invisible|#t_enemy
    ret

;; remove the invisible type
change_enemy_type_opaco:
    ld e_type(ix), #t_enemy
    ret


;; INPUT: IX entity, BC sprite
assign_sprite:
    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    ret

assign_anim:
    ld e_animated_l(ix), c
    ld e_animated_h(ix), b
    ret

;;INPUT : IX entity
behaviour_fantasma:
    ld a, e_estado_ia(ix)
    cp #default_state
    jr nz, opaco

pasa_a_opaco:
    call change_enemy_type_opaco ;; lo pone
    call reset_fantasma_movement_normal
    call reset_fantasma_estado_normal
    ld bc, #fantasma_sprite_opaco1
    call assign_sprite
    ld bc, #anim_fantasma_opaco
    call assign_anim
    ld e_estado_ia(ix), #estado_opaco
opaco:
    ld a, e_estado_ia(ix)
    cp #estado_opaco
    jr nz, transparente

    ld hl, #counter_fantasma_estado
    dec (hl) 
    jr z, pasa_a_transparente

    ld b, #tiempo_movement_time_normal
    call mueve_fantasma 
    ret
pasa_a_transparente:
    call change_enemy_type_inv ;; lo quita
    call reset_fantasma_movement_transparente
    call reset_fantasma_estado_transparente
    ld bc, #fantasma_sprite_transparente1
    call assign_sprite
    ld bc, #anim_fantasma_transparente
    call assign_anim
    ld e_estado_ia(ix), #estado_transparente
transparente:

    ld hl, #counter_fantasma_estado
    dec (hl) 
    jr z, pasa_a_opaco

    ld b, #tiempo_movement_time_transparente
    call mueve_fantasma 
    ret

;;INPUT : IX entity
behaviour_pato::
    ld a, e_x0(ix)
    
    cp #4
    jr z, pato_on_left_of_screen
    cp #75 - 4
    jr z, pato_on_right_of_screen
    jr update_ai_y

    pato_on_left_of_screen:
    ld e_vx(ix), #1
    jr update_ai_y

    pato_on_right_of_screen:
    ld e_vx(ix), #-1
    jr update_ai_y

    update_ai_y:
    ld a, e_y0(ix)
    cp #18
    jr c, pato_on_the_upper_limit_of_screen
    cp #200 - 32
    jr z, pato_on_the_bottom_limit_of_screen
    ld a, #0b00000011
    call get_random    
    sub e_estado_ia(ix)
    ld e_vy(ix), a
    ret

    pato_on_the_upper_limit_of_screen:
        ld e_vy(ix), #1
        ld e_estado_ia(ix), #basic_pato_down_state
        ret

    pato_on_the_bottom_limit_of_screen:
        ld e_vy(ix), #-1
        ld e_estado_ia(ix), #basic_pato_up_state
    ret

;; para los patos pequeños
behaviour_pato_otro_eje::
    ld a, e_y0(ix)

    cp #20
    jr z, pato_on_up_of_screen
    cp #screen_height - 16
    jr z, pato_on_down_of_screen
    jr update_ai_x

    pato_on_up_of_screen:
    ld e_vy(ix), #1
    jr update_ai_x

    pato_on_down_of_screen:
    ld e_vy(ix), #-1
    jr update_ai_x

    update_ai_x:

    ld a, e_x0(ix)
    
    cp #5
    jr z, pato_on_the_left_limit_of_screen
    cp #75 - 4
    jr z, pato_on_the_right_limit_of_screen

    ld a, e_estado_ia(ix)
    cp #sinusoidal_pato/2+1
    jr c, mueve_negativo
    ld e_vx(ix), #1
    jr end_if_pato
    mueve_negativo:
    ld e_vx(ix), #-1
end_if_pato:
    ld a, e_estado_ia(ix)
    dec a 
    jr z, resetea_estado
    ld e_estado_ia(ix), a
    ret

    resetea_estado:
    ld e_estado_ia(ix), #sinusoidal_pato
    ld e_vx(ix), #-1
    ret

    pato_on_the_left_limit_of_screen:
        ld e_vx(ix), #1
        ld e_estado_ia(ix), #sinusoidal_pato
        ret

    pato_on_the_right_limit_of_screen:
        ld e_vx(ix), #-1
        ld e_estado_ia(ix), #sinusoidal_pato/2
    ret

;; Moves between reflective_big_pato_leftmost_x and reflective_big_pato_leftmost_y
;; This happens reflective_big_pato_invulnerable_cycles times.
;; There is a small chance the big pato will move down and then up
;; Then big pato dies and spawns a small fast pato
behaviour_reflective_pato_big::
    ld a, e_x0(ix)
    
    cp #reflective_big_pato_leftmost_x
    jp c, turn_right_big_pato_reflective
    cp #reflective_big_pato_rightmost_x
    jp nc, turn_left_big_pato_reflective
    cp #big_pato_screen_middle
    jp z, #update_big_pato_cycles

    call cpct_getRandom_mxor_u8_asm
    ld a, #249 ; 0.0234375% chance
    cp l
    jr c, big_pato_go_down_and_up
    ret

    big_pato_go_down_and_up:
    ld e_vy(ix), #4
    ld a, e_vx(ix)
    ld (reflective_big_pato_old_vx), a
    ld e_vx(ix), #0

    ;;load new behaviour
    ld hl, #behaviour_reflective_pato_big_vertical
    ld e_ai_behaviour_h(ix), h
    ld e_ai_behaviour_l(ix), l

    ret

    turn_right_big_pato_reflective:
    ld e_vx(ix), #1
    ret

    turn_left_big_pato_reflective:
    ld e_vx(ix), #-1
    ret

    update_big_pato_cycles:
    ld a, #256 / reflective_big_pato_invulnerable_cycles
    add a, e_estado_ia(ix)
    jr c, finalize_big_pato
    ld e_estado_ia(ix), a
    ret

    finalize_big_pato:
    ld hl, #small_pato_update_vx_cycle ; Reset update vx cycles (for small pato)
    ld (hl), #0

    ld e_type(ix), #t_toBeKilled ;; kill big pato
    ld hl, #level_enemies ;; Decrementar el counter del nivel
	dec (hl)
    ld hl, #reflective_pato_small_entity ;; create small pato
    call man_entity_create
    ret

;; When the big pato goes down and then up in a straight line
behaviour_reflective_pato_big_vertical:
    ld a, e_y0(ix)
    cp #24
    jr c, end_vertical_pato_big

    ld hl, #reflective_big_pato_update_vy_cycles
    dec (hl)
    jr z, reflective_big_pato_update_vy
    ret

    reflective_big_pato_update_vy:
    dec e_vy(ix)
    ld (hl), #reflective_big_pato_update_vy_vertical_default

    ret

    end_vertical_pato_big:
    ld a, #reflective_big_pato_update_vy_vertical_default
    ld (reflective_big_pato_update_vy_cycles), a
    ld a, (reflective_big_pato_old_vx)
    ld e_vx(ix), a
    ld e_vy(ix), #0
    ld e_y0(ix), #21

    ld hl, #behaviour_reflective_pato_big
    ld e_ai_behaviour_h(ix), h
    ld e_ai_behaviour_l(ix), l

    ret

;;INPUT IX = small pato
;;pato going down = state 0
;;pato going up = state 1
behaviour_reflective_pato_small::
;   check pato state
    ld a, #0
    cp e_estado_ia(ix)
    jr nz, fast_pato_going_up

;   pato is flying down
    ;;Check return_up_x_y == fast pato's x and y
    ld b, e_x0(ix)
    ld c, e_y0(ix)
    
    ld hl, #fast_pato_return_up_x_y
    or a
    sbc hl, bc
    jr z, go_up

    ld hl, #small_pato_update_vx_cycle
    ld a, (hl)
    cp #0
    jr nz, decrease_vx_cycle

    dec e_vx(ix)
    ld (hl), #small_pato_update_vx_max_cycles
    ret

    decrease_vx_cycle:
    dec (hl)
    ret

    go_up:
    ld e_estado_ia(ix), #1
    ld hl, #small_pato_update_vx_cycle
    ld (hl), #0
    ld e_vx(ix), #-3
    ld e_vy(ix), #-3
    ret

    fast_pato_going_up:
    ;;Check imback_x_y == fast pato's x and y
    ld b, e_x0(ix)
    ld c, e_y0(ix)
    
    ld hl, #fast_pato_imback_x_y
    or a
    sbc hl, bc
    jr z, end_fast_small_pato

    ld hl, #small_pato_update_vx_cycle
    ld a, (hl)
    cp #0
    jr nz, decrease_vx_cycle

    inc e_vx(ix)
    ld (hl), #small_pato_update_vx_max_cycles
    ret

    end_fast_small_pato:
    ld hl, #small_pato_update_vx_cycle ; Reset update vx cycles
    ld (hl), #0

    call kill_entity_ix_not_enemy

    ld hl, #reflective_pato_big_entity ;; create BIG pato
    call man_entity_create
    ret
    
behaviour_tanque:
    ld a, e_animated_l(ix)
    dec a
    ld e_animated_l(ix), a

    ;; Comprobamos que no hayan dos balas al mismo tiempo en el mapa.
    ld a, e_animated_l(ix)
    ld b, #1
    cp b
    jp nz, mueve_tanque

    ;;  En caso de que no haya ninguna se procede a confirmar que se ha creado(va a crear) una. 
    ld a, #0x1F
    call get_random
    add #time_tanque_shoot
    ld e_animated_l(ix), a

    ;; Almacenamos la posición de la entidad tanque para posicionar la bala.
    ld b, e_x0(ix)
    ld c, e_y0(ix)
    
    ;; Guardamos la entidad actual.
    push ix

    ;; Para la velocidad de la bala tenemos que comprobar hacia donde va a ir.
    bala_from_right:
        ld a, e_orientation(ix)
        cp #o_right
        jr nz, bala_from_down

        ld a, e_y0(ix)
        cp #19 
        jr c, bala_from_down

        ;; Le añadimos las coordenadas y posición correspondientes a la bala
        ld ix, #bala_enemy
        call tanque_set_3_x_3_y_bullet
        ld e_vx(ix), #vel_balae_l
        ld e_vy(ix), #0
        ld a, e_y0(ix)
        add #0x06 ;; La altura desde la cual disparará el tanque.
        ld e_y0(ix), a
        ld a, e_x0(ix)
        sub #2
        ld e_x0(ix), a
        jp bala_horizontal

    bala_from_down:
        ld a, e_orientation(ix)
        cp #o_down
        jr nz, bala_from_left
        ;; Le añadimos las coordenadas y posición correspondientes a la bala
        ld ix, #bala_enemy
        call tanque_set_3_x_3_y_bullet
        ld e_vx(ix), #0
        ld e_vy(ix), #vel_balae_u
        ld a, e_y0(ix)
        add #0x0A ;; La altura desde la cual disparará el tanque.
        ld e_y0(ix), a
        ld a, e_x0(ix)
        add #player_width-#margen+#1 ;;ya tiene un margen el sprite
        ld e_x0(ix), a
        jr bala_vertical

    bala_from_left:
        ld a, e_orientation(ix)
        cp #o_left
        jr nz, bala_from_up

        ;; Le añadimos las coordenadas y posición correspondientes a la bala
        ld ix, #bala_enemy
        call tanque_set_3_x_3_y_bullet
        ld e_vx(ix), #vel_balae_r
        ld e_vy(ix), #0
        ld a, e_y0(ix)
        add #0x06 ;; La altura desde la cual disparará el tanque.
        ld e_y0(ix), a
        ld a, e_x0(ix)
        add #player_width-#margen ;;ya tiene un margen el sprite
        ld e_x0(ix), a
        jr bala_horizontal

    bala_from_up:
        ;; Le añadimos las coordenadas y posición correspondientes a la bala
        ld ix, #bala_enemy
        call tanque_set_3_x_3_y_bullet
        ld e_vx(ix), #0
        ld e_vy(ix), #vel_balae_d
        ;; Actualizamos la posición de la bala considerando el tamaño del tanque.
        ld a, e_y0(ix)
        add #0x0A ;; La altura desde la cual disparará el tanque.
        ld e_y0(ix), a
        ld a, e_x0(ix)
        add #0x06 ;;ya tiene un margen el sprite
        ld e_x0(ix), a

    bala_vertical:
        ;; Le añadimos las propiedades de altura anchura y posición del sprite correspondientes a la bala.
        ld bc, #bala_h_enemy_sprite
        ld e_sprite_l(ix), c
        ld e_sprite_h(ix), b
        ld e_w(ix), #bala_width_vertical
        ld e_h(ix), #bala_height_vertical
        jr crear_bala

    bala_horizontal:
        ;; Le añadimos las propiedades de altura anchura y posición del sprite correspondientes a la bala.
        ld bc, #bala_w_enemy_sprite
        ld e_sprite_l(ix), c
        ld e_sprite_h(ix), b
        ld e_w(ix), #bala_width_horizontal
        ld e_h(ix), #bala_height_horizontal

    crear_bala:
        ld hl, #bala_enemy
        call man_entity_create
        pop ix

    mueve_tanque:
        ld a, e_y0(ix)
        cp #19
        jr c, tanque_on_the_upper_limit_of_screen
        cp #screen_height - 16
        jr z, tanque_on_the_bottom_limit_of_screen
        ret

        tanque_on_the_upper_limit_of_screen:
            ld e_orientation(ix), #o_up
            ld bc, #tanque_sprite2
            ld e_sprite_l(ix), c
            ld e_sprite_h(ix), b
            ld e_vy(ix), #0
            ld e_vx(ix), #1
            ld a, e_x0(ix)
            cp #screen_width - 4
            jr z, tanque_on_the_right_limit_of_screen
            ret

        tanque_on_the_bottom_limit_of_screen:
            ld bc, #tanque_sprite4
            ld e_sprite_l(ix), c
            ld e_sprite_h(ix), b
            ld e_orientation(ix), #o_down
            ld e_vx(ix), #-1
            ld e_vy(ix), #0
            ld a, e_x0(ix)
            cp #4
            jr z, tanque_on_the_left_limit_of_screen
            ret

        tanque_on_the_right_limit_of_screen:
            ld bc, #tanque_sprite3
            ld e_sprite_l(ix), c
            ld e_sprite_h(ix), b
            ld e_orientation(ix), #o_right
            ld e_vx(ix), #0
            ld e_vy(ix), #3
            ret

        tanque_on_the_left_limit_of_screen:
            ld bc, #tanque_sprite1
            ld e_sprite_l(ix), c
            ld e_sprite_h(ix), b
            ld e_orientation(ix), #o_left
            ld e_vy(ix), #-3
            ld e_vx(ix), #0
    ret


;; This functions sets x0 = x1 = x2 and y0 = y1 = y2 for the tanque's bullet (black bullet)
;; INPUT : IX (tanque's bullet)
;;         BC (x, y)
;; DESTROYS: 
tanque_set_3_x_3_y_bullet:
    ld e_x0(ix), b
    ld e_x1(ix), b
    ld e_x2(ix), b
    ld e_y0(ix), c
    ld e_y1(ix), c
    ld e_y2(ix), c
    ret

