.module input

.include "cpctelera.h.s"
.include "input.h.s"
.include "man/entity.h.s"
.include "man/animation.h.s"
.include "assets/template.h.s"
.include "assets/sprites.h.s"
.include "sys/render.h.s"



sys_input_init::
    ret

;; Before calling man_entity_create, this functions sets x1 = x2 = (x0 + vx) and y1 = y2 = (y0 + vy) 
;; INPUT : IX entity (x0 and y0 have to set)
;; INPUT : HL entity (yes, we need to point to the same address twice)
;; DESTROYS : AF BC HL DE
create_bullet_w_3_coordinates:
    ld a, e_x0(ix)
    add e_vx(ix)
    ld e_x1(ix), a
    ld e_x2(ix), a
    ld a, e_y0(ix)
    add e_vy(ix)
    ld e_y1(ix), a
    ld e_y2(ix), a

    call man_entity_create
    ret

;; TODO Por ahora se asume que solo la entidad 0 es controlada
;; INPUT IX: pointer to player
;; DESTROY: AF,  BC, DE, HL, IX 
sys_input_update::
    ld ix, #_entity_array ;; La primera entidad es el jugador(taco)
    ;;Resetea velocidades
    ld e_vx(ix), #0
    ld e_vy(ix), #0

    ;; Hay que checkear letra a letra
    ld hl, #Key_O ;;Izquierda
    call cpct_isKeyPressed_asm
    jr z, O_NotPressed
O_Pressed:
    ld e_vx(ix), #vel_player_l

    jr A_NotPressed ;; Para no ir en diagonal
O_NotPressed:

    ld hl, #Key_P ;;Derecha
    call cpct_isKeyPressed_asm
    jr z, P_NotPressed
P_Pressed:
    ld e_vx(ix), #vel_player_r

    jr A_NotPressed ;; Para no ir en diagonal
P_NotPressed:

    ld hl, #Key_Q ;;Arriba
    call cpct_isKeyPressed_asm
    jr z, Q_NotPressed
Q_Pressed:
    ld e_vy(ix), #vel_player_u

    jr A_NotPressed ;; Para no ir en diagonal
Q_NotPressed:
    ld hl, #Key_A ;;Abajo
    call cpct_isKeyPressed_asm
    jr z, A_NotPressed
A_Pressed:

    ld e_vy(ix), #vel_player_d

A_NotPressed:

    ld hl, #Key_Space ;;Disparar bala
    call cpct_isKeyPressed_asm
    jp z, Space_NotPressed
Space_Pressed:
    ld hl, #new_bala
    ld a, (hl)
    ld b, #1
    cp b
    jp nz, Space_NotPressed ;; Cuando no es 1 salta


    ;;ld a, (tiempo_bala)     
    ld a, #0
    ld (hl), a

    ld a, e_orientation(ix) ;; Las orientaciones son de 1 a 4

    ld b, e_x0(ix)
    ld c, e_y0(ix)
    
    
    ld ix, #bala_lettuce
    ld e_x0(ix), b
    ld e_y0(ix), c
    

    ld hl, #bala_lettuce
    
    dec a
    jp z, disparar_arriba

    dec a 
    jp z, disparar_abajo

    dec a
    jp z, disparar_derecha

    dec a
    jp z, disparar_izquierda

jp final

disparar_arriba:
    ld e_orientation(ix), #o_up
    ;; no hace falta hacer push ix porque sale de la función
    ld e_vy(ix), #vel_bala_u ;; TODO No se si es lo más óptimo
    ld e_vx(ix), #0

    ;; Colocar la bala desde el centro del personaje
    ld a, e_x0(ix)
    add #player_width_medio
    ld e_x0(ix), a
    ld a, e_y0(ix)
    sub #margen-#2
    ld e_y0(ix), a
    

    ld bc, #bala_h_sprite
    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    ld e_w(ix), #bala_width_vertical
    ld e_h(ix), #bala_height_vertical
    
    call create_bullet_w_3_coordinates
jp final

disparar_abajo:
    ld e_orientation(ix), #o_down
    ld e_vy(ix), #vel_bala_d 
    ld e_vx(ix), #0

    ld a, e_x0(ix)
    add #player_width_medio
    ld e_x0(ix), a
    ld a, e_y0(ix)
    add #player_height-#margen
    ld e_y0(ix), a
    

    ld bc, #bala_h_sprite
    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    ld e_w(ix), #bala_width_vertical
    ld e_h(ix), #bala_height_vertical


    call create_bullet_w_3_coordinates
jr final

disparar_derecha:
    ld e_orientation(ix), #o_right
    ld e_vx(ix), #vel_bala_r 
    ld e_vy(ix), #0

    ld a, e_y0(ix)
    add #player_height_medio
    ld e_y0(ix), a
    ld a, e_x0(ix)
    add #player_width-#margen ;;ya tiene un margen el sprite
    ld e_x0(ix), a
    

    ld bc, #bala_w_sprite
    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    ld e_w(ix), #bala_width_horizontal
    ld e_h(ix), #bala_height_horizontal


    call create_bullet_w_3_coordinates
jr final

disparar_izquierda:
    ld e_orientation(ix), #o_left
    ld e_vx(ix), #vel_bala_l 
    ld e_vy(ix), #0

    ld a, e_y0(ix)
    add #player_height_medio
    ld e_y0(ix), a
    ld a, e_x0(ix)
    add #margen-#1
    ld e_x0(ix), a
    


    ld bc, #bala_w_sprite
    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    ld e_w(ix), #bala_width_horizontal
    ld e_h(ix), #bala_height_horizontal

    call create_bullet_w_3_coordinates
jr final

Space_NotPressed:
    jr final

final:

ret
