.module physics

.include "physics.h.s"
.include "man/entity.h.s"
.include "assets/template.h.s"


sys_physics_init::
    ret


;; Actualizar fisica del objeto, todos los componentes. Asume todos los componentes contiguos y válidos. Al menos una entidad en el array
;; DESTROY: AF, BC, DE, IX
;; STACK 2 bytes

sys_physics_update::
	call man_entity_getArray

    ld hl, #sys_physics_update_entity
    call man_entity_forall
    ret

;; Actualizar fisica de una entidad.
;; Sólo eliminará la entidad si es una bala y se sale por los bordes.
;; INPUT: IX entity 
;; DESTROY: AF, BC, DE, IX
;; STACK 2 bytes
sys_physics_update_entity:

    ;;UPDATE X
    ld a, #screen_width + 1
    sub e_w(ix)             ;; tamaño max de pantalla menos nuestra posicion, para comprobar que no nos hemos pasado
    ld c, a

    ld a, e_x0(ix)
    add e_vx(ix)    ;; actualizar x con la velocidad
    cp c           ;; comparo con c. Es una resta por lo que acarrea si c es menor solo
    jr nc, invalida
    
    ;; COMPROBAMOS QUE NO SE SALGA DEL MAPA POR LA IZQUIERDA
    ld c, #4
    ld a, e_x0(ix)
    add e_vx(ix)    ;; actualizar x con la velocidad
    cp c           ;; comparo con c. Es una resta por lo que acarrea si c es menor solo
    jr c, invalida

valida_x:
    ld e_x0(ix), a
    jr endif_x

invalida:
    ld a, #t_bala|#t_bala_enemy
    and e_type(ix)
    ret z
    ld a, e_type(ix)
    or #t_toBeKilled
    ld e_type(ix), a
    ret

endif_x:

    ;;UPDATE Y
    ld a, #screen_height + 1
    sub e_h(ix)             ;; tamaño max de pantalla menos nuestra posicion, para comprobar que no nos hemos pasado
    ld c, a

    ld a, e_y0(ix)
    add e_vy(ix)    ;; actualizar y con la velocidad
    cp c           ;; comparo con c. Es una resta por lo que acarrea si c es menor solo
    jr nc, invalida

    ;; COMPROBAMOS QUE NO SE SALGA DEL MAPA POR ARRIBA
    ld c, #15
    ld a, e_y0(ix)
    add e_vy(ix)    ;; actualizar x con la velocidad
    cp c           ;; comparo con c. Es una resta por lo que acarrea si c es menor solo
    jr c, invalida

valida_y:
    ld e_y0(ix), a
    

endif_y:
    ret

