.module render

.include "cpctelera.h.s"
.include "render.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "assets/sprites.h.s"
.include "assets/template.h.s"
.include "man/music.h.s"


.globl cpct_getScreenPtr_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setVideoMode_asm
.globl cpct_memset_asm
.globl cpct_drawCharM1_asm
.globl cpct_drawStringM1_f_asm

.globl _g_tileset_00
.globl _tilemap_array

.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_etm_drawTilemap4x8_ag_asm

;; 1 or 0
backbuffer_in_use::
    .dw backbuffer_add

backbuffer_not_in_use::
    .dw video_mem_add


.macro sys_render_alloc_backbuffer
    ld de, #0x8000
    ld a, #0
    ld bc, #0x4000 ;;16KB
    call cpct_memset_asm
.endm


;; Shifts x's and y's one to the right
;; Reduces frames_to_draw by 1
;; INPUT IX (entity)
.macro sys_render_entity_drawn_update
    ;;x2 = x1
    ld a, e_x1(ix)
    ld e_x2(ix), a
    ;;x1 = x0
    ld a, e_x0(ix)
    ld e_x1(ix), a
    ;;y2 = y1
    ld a, e_y1(ix)
    ld e_y2(ix), a
    ;;y1 = y0
    ld a, e_y0(ix)
    ld e_y1(ix), a
.endm

lvl_text:
	.asciz "lvl"

lives_text:
	.asciz "lives: "

;;Initialize render 
sys_render_init::

    ; sys_render_alloc_backbuffer
    ;; VIDEO MODE = 1
    ld c, #1
    call cpct_setVideoMode_asm

    ;; PALETTE = RED GREEN BLACK PASTEL_YELLOW
    ld hl, #main_palette
    ld de, #4
    call cpct_setPalette_asm

    ;; BORDER = RED
    cpctm_setBorder_asm HW_RED

    ld c, #20
    ld b, #25
    ld de, #20
    ld hl, #_g_tileset_00
    call cpct_etm_setDrawTilemap4x8_ag_asm
    
    ld hl, #video_mem_add
    ld de, #_tilemap_array
    call cpct_etm_drawTilemap4x8_ag_asm
    
    ld hl, #backbuffer_add
    ld de, #_tilemap_array
    call cpct_etm_drawTilemap4x8_ag_asm

    enable_music

    call draw_marcador

    ld de, #screen_start
    ld c, #screen_width - 12
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl ;; DE ScreenPointer, HL points

    ret


;; Draws the time left of the user
draw_marcador:

    ld de, #backbuffer_add
    ld c, #screen_width - 14
    ld b, #2
    call cpct_getScreenPtr_asm
    ex de, hl ;; lo devuelve en hl, y necesitamos de

    ld a, #0x0F
    ld c, #12
    ld b, #12
    call cpct_drawSolidBox_asm

    ld de, #video_mem_add
    ld c, #screen_width - 14
    ld b, #2
    call cpct_getScreenPtr_asm
    ex de, hl ;; lo devuelve en hl, y necesitamos de

    ld a, #0x0F
    ld c, #12
    ld b, #12
    call cpct_drawSolidBox_asm

ret

;; INPUT: BC: number of points to increase
;; DESTROY: AF, HL, BC, DE
add_points::
    ld hl , #user_points
    ld e, (hl)
    inc hl
    ld d, (hl) 
    dec hl

    ld a, e
    add a, c
    ld a, d 
    sbc a, b
    jr nc, menor1000 
    ld (hl), #99 
    inc hl 
    ld (hl), #99 
    ret

menor1000:
    ld a, e 
    add c 
    daa 
    ld (hl), a 
    inc hl 

    ld a, d 
    adc b 
    daa
    ld (hl), a 
    ret 


;; INPUT BC: number of points to dec
;; DESTROY: AF, HL, BC, DE
dec_points::
    ld hl , #user_points
    ld e, (hl)
    inc hl
    ld d, (hl) 
    dec hl

    ld a, e
    sub a, c
    ld a, d 
    sbc a, b
    jr nc, mayor0 
    ld (hl), #00 
    inc hl 
    ld (hl), #00 
    ret

mayor0:
    ld a, e 
    sub c 
    daa 
    ld (hl), a 
    inc hl 

    ld a, d 
    sbc b 
    daa
    ld (hl), a 
    ret 

;; INPUT DE: ScreenPtr
;; Draws the variable with the punctuation
draw_time_points::

    ld hl, #user_points

    push hl 
    ld b, (hl)
    inc hl
    ld h, (hl)
    ld l, b    ;; ld hl, (hl)
    ex af, af'
    ld bc, #0000
    ld a, l 
    add c 
    daa 
    ld l, a 
    
     ;; ScreenPtr
    ld a, h
    adc b 
    daa 
    ld h, a 

    ld a, h
    and #0x0F
    add #48
    ld b, a ;; High part
    ld a, h 
    rra
    rra 
    rra 
    rra 
    and #0x0F
    add #48
    ld c, a ;; Low part

    ex de, hl ;; de points, hl ScreenPtr
    push bc
    push hl 
    push de 
    ld e, c
    call cpct_drawCharM1_asm
    pop de 
    pop hl 
    pop bc 
    inc hl
    inc hl

    push hl 
    push de 
    ld e, b
    call cpct_drawCharM1_asm
    pop de 
    pop hl 
    inc hl
    inc hl
    
;; Low byte

    ex de, hl ;; de ScreenPtr, hl points

 ;; ScreenPtr

    ld a, l
    and #0x0F
    add #48
    ld b, a ;; High part
    ld a, l
    rra
    rra 
    rra 
    rra 
    and #0x0F
    add #48
    ld c, a ;; Low part

    ex de, hl ;; de points, hl ScreenPtr
    push bc
    push hl 
    ld e, c
    call cpct_drawCharM1_asm
    pop hl 
    pop bc 
    inc hl
    inc hl

    push hl 
    ld e, b
    call cpct_drawCharM1_asm
    pop hl 

    ex af, af'
    inc hl 
    inc hl 
    ex de, hl
    pop hl 
ret

;;INPUT DE : video_mem_origin
;; Draws the left lifes of the user
draw_vidas_level::
    push de
    push de

    ld c, #5
    ld b, #2
    call cpct_getScreenPtr_asm
    ex de, hl ;; lo devuelve en hl, y necesitamos de

    ld a, #0x0F
    ld c, #13
    ld b, #12
    call cpct_drawSolidBox_asm

    pop de
    ld c, #5
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl 

    call draw_all_lives

    pop de
    ;;draw_level
    ld c, #screen_width/2 - 3
    ld b, #2
    call cpct_getScreenPtr_asm
    ex de, hl 

    ld a, #0x0F
    ld c, #11
    ld b, #12
    call cpct_drawSolidBox_asm

    
    ld de, #screen_start
    ld c, #screen_width/2 - 3
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl 
    call draw_lvl_chars

    ld de, #screen_start
    ld c, #screen_width/2 + 4
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl 
    draw_lvl_numbers_twice
ret

;; INPUT: DE: ScreenPtr relative to C000
;; Draws lvl characters IN BOTH BUFFERS (C000 and 8000)
draw_lvl_chars::
    push de
    ld hl, #lvl_text
	ld c, #1
    ld b, #2
	call cpct_drawStringM1_f_asm

    ;;de -= 0x4000
    or a
    ld bc, #0x4000
    pop hl ;; hl = de
    sbc hl, bc
    ex de, hl

    ld hl, #lvl_text
	ld c, #1
    ld b, #2
	call cpct_drawStringM1_f_asm

    ret

;; INPUT: DE: ScreenPtr relative to C000
;; Draws lvl characters IN BOTH BUFFERS (C000 and 8000)
draw_lives_chars::
    push de
    ld hl, #lives_text
	ld c, #3
    ld b, #2
	call cpct_drawStringM1_f_asm

    ;;de -= 0x4000
    or a
    ld bc, #0x4000
    pop hl ;; hl = de
    sbc hl, bc
    ex de, hl

    ld hl, #lives_text
	ld c, #3
    ld b, #2
	call cpct_drawStringM1_f_asm

    ret

;; INPUT: DE: ScreenPtr
;; Draws life
draw_number_life:

    ld hl, #vidas_taco

    ld b, (hl)
    ld c, b ;; As a copy
    ld a, b
    and #0x0F
    add #48
    
    ld b, a ;; High part
    ld a, c 
    rra
    rra 
    rra 
    rra 
    and #0x0F
    add #48
    ld c, a ;; Low part


    ex de, hl ;; de lvl, hl ScreenPtr
    push bc
    push hl 

    push bc
    push hl 
    ld e, #0
	ld d, #2
    call cpct_setDrawCharM1_asm
    pop hl 
    pop bc 

    ld e, c

    call cpct_drawCharM1_asm

    ld de, #0x4000
    sbc hl, de

    pop hl 
    pop bc 
    inc hl
    inc hl

    ld e, b
    call cpct_drawCharM1_asm

    ret

;; INPUT: DE: ScreenPtr
;; Draws lvl
draw_lvl:

    ld hl, #actual_lvl

    ld b, (hl)
    ld c, b ;; As a copy
    ld a, b
    and #0x0F
    add #48
    
    ld b, a ;; High part
    ld a, c 
    rra
    rra 
    rra 
    rra 
    and #0x0F
    add #48
    ld c, a ;; Low part


    ex de, hl ;; de lvl, hl ScreenPtr
    push bc
    push hl 

    push de 
    push bc
    push hl 
    ld e, #1
	ld d, #2
    call cpct_setDrawCharM1_asm
    pop hl 
    pop bc 
    pop de  

    ld e, c

    call cpct_drawCharM1_asm

    ld de, #0x4000
    sbc hl, de

    pop hl 
    pop bc 
    inc hl
    inc hl

    ld e, b
    call cpct_drawCharM1_asm

    ret

;; INPUT DE: ScreenPtr
;; Draws and checks lives
draw_all_lives:

    ld hl, #vidas_taco
	ld a, (hl)
    loop_lives:
        or a 
        ret z

        dec a
        ex af, af'
        push de 
        ld hl, #vidas_sprite
        ld c, #player_width
        ld b, #8
        call cpct_drawSprite_asm
        pop de 
        ld a, e 
        add a, #4
        ld e, a
        ex af, af'
        jr loop_lives
        ret


;; Dibuja todos los componentes
;; DESTROY: AF, HL, BC, DE, IX
;; STACK 2by
sys_render_update:: ;; Luego hará más cosas
	call man_entity_getArray

    ld hl, #sys_render_update_entity ;; Render all entities

    call man_entity_forall

    ret

;; Checks if entity was created during this frame
;; INPUT: IY
;; DESTROY: A
;; RETURNS: bit z
check_just_created_iy::
    xor a
    cp e_x1(iy)
    ret

;; Checks if entity was created during this frame
;; INPUT: IX
;; DESTROY: A
;; RETURNS: bit z
check_just_created_ix::
    xor a
    cp e_x1(ix)
    ret


;; Updates entity only if is not t_toBeKilled
;; Clears from (x2, y2)
;; Draws in (x0, x0)
;; INPUT
;; IX: entity memory address
;; DESTROY: AF, HL, BC, DE
sys_render_update_entity:

    ld a, #t_toBeKilled
    and e_type(ix)
    ret nz

    ;;de = (x2, y2)
    ld de, (backbuffer_in_use)
    ld c, e_x2(ix) 
    ld b, e_y2(ix)
    call cpct_getScreenPtr_asm
    ex de, hl

    ;;clear entity
    xor a ; a = 0
    ld c, e_w(ix)
    ld b, e_h(ix)
    push bc
    call cpct_drawSolidBox_asm

    ;;de = (x0, y0)
    ld de, (backbuffer_in_use)
    ld c, e_x0(ix) 
    ld b, e_y0(ix)
    call cpct_getScreenPtr_asm
    ex de, hl

    ;;draw entity
    ;;hl = e_sprite
    ld h, e_sprite_h(ix)
    ld l, e_sprite_l(ix)
    pop bc
    call cpct_drawSprite_asm

    sys_render_entity_drawn_update

    ret

.macro check_e_inside_map label_to_jump
    ld a, #3
    cp c
    jr nc, label_to_jump
    ld a, #75
    cp c
    jr c, label_to_jump

    ld a, #15
    cp b
    jr nc, label_to_jump
    ld a, #181
    cp b
    jr c, label_to_jump
.endm

;;Erases sprite from both memory buffers (if they are inside the map)
;;INPUT : IX (entity)
sys_render_clean_entity::
    
    ;;de = (x2, y2)
    ld de, (backbuffer_in_use)
    ld c, e_x2(ix) 
    ld b, e_y2(ix)
    
    check_e_inside_map dont_clean_x2_y2
    
    call cpct_getScreenPtr_asm
    ex de, hl

    ;;clear
    xor a ; a = 0
    ld c, e_w(ix)
    ld b, e_h(ix)
    call cpct_drawSolidBox_asm

    dont_clean_x2_y2:


    ;;de = (x1, y1)
    ld de, (backbuffer_not_in_use)
    ld c, e_x1(ix) 
    ld b, e_y1(ix)

    check_e_inside_map dont_clean_x1_y1

    call cpct_getScreenPtr_asm
    ex de, hl

    ;;clear
    xor a ; a = 0
    ld c, e_w(ix)
    ld b, e_h(ix)
    call cpct_drawSolidBox_asm

    dont_clean_x1_y1:
    ret


sys_render_switch_buffers::
    ld hl, (backbuffer_in_use)
    ld de, #backbuffer_add
    push de
    or a
    sbc hl, de
    add hl, de
    ld hl, #backbuffer_in_use
    jr nz, switch_to_8000

    switch_to_c000:
    ld (hl), #video_mem_add_l
    inc hl
    ld (hl), #video_mem_add_h
    ld l, #video_mem_page_shifted
    call cpct_setVideoMemoryPage_asm

    ld hl, #backbuffer_not_in_use
    pop de
    ld (hl), e
    inc hl
    ld (hl), d

    ret

    switch_to_8000:
    pop de
    ld (hl), e
    inc hl
    ld (hl), d
    ld l, #backbuffer_page_shifted
    call cpct_setVideoMemoryPage_asm

    ld hl, #backbuffer_not_in_use
    ld (hl), #video_mem_add_l
    inc hl
    ld (hl), #video_mem_add_h

    ret

