.module sysanimation

.include "syscol.h.s"
.include "cpctelera.h.s"
.include "man/collision.h.s"
.include "man/animation.h.s"
.include "assets/template.h.s"
.include "assets/sprites.h.s"


;; DESTROY: HL
sys_animation_init::
    call man_animation_getArray_HL  
    ld (animation_array_prt), hl
    ret

;; Updates all entities
sys_animation_update::

animation_array_prt = .+1
    ld hl, #0x0000

loop:
    ;;Get pointer to next entity in DE
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl          ;; HL += 2 (Next pointer)


    ld a, e 
    or d 
    ret z

    ld__ixl_e 
    ld__ixh_d
    ld a, e_type(ix)
    cp #t_default
    jr z, loop

    call calculateAnimationOrientation ;; Calcula la orientacion no asignada todavía para ver si cambia

    ld a, e_type(ix)
    cp #t_enemy
    jr nz, sys_animation_no_big_pato
    ld a, e_enemy_type(ix)
    cp #et_reflective_pato_big
    jr z, noCambiaOrientation

    sys_animation_no_big_pato:

    ld a, e_orientation(ix) ;; La anterior
    cp b 
    jr z, noCambiaOrientation
cambioOrientation:
    ld e_orientation(ix), b

    ex de, hl 
    call man_animation_getAnimHL
    ld e_animated_l(ix), l ;; Guarda la siguiente posicion en la entidad
    ld e_animated_h(ix), h 

    ex de, hl
    jp siguiente_animacion
noCambiaOrientation::

    ;; Counter de sprite
    ld a, e_frames_animation(ix)
    or a 
    jp z, CambiaSprite ;; Si es 0 el counter
noCambiaSprite: 
    dec e_frames_animation(ix)
    jr loop
CambiaSprite:
    call man_animation_setAnimTimeout
    jp siguiente_animacion

siguiente_animacion:
    ld e, e_animated_l(ix) ;; DE = siguiente paso de la animacion
    ld d, e_animated_h(ix)
    ex de, hl

continua_animation:
    ld c, (hl)   
    inc hl 
    ld b, (hl)  ;; BC = Siguiente sprite
    inc hl      ;; HL += 2, siguiente paso de la animacion
    
    ld a, c                 ;; Si es nullptr se resetea
    or b 
    jr z, fin_animation
    

    ld e_animated_l(ix), l ;; Guarda la siguiente posicion en la entidad
    ld e_animated_h(ix), h 
    
    ld e_sprite_l(ix), c         
    ld e_sprite_h(ix), b         

    ex de, hl

    jr loop

fin_animation:
    ld a, (hl) 
    inc hl     ;; HL = (HL), de esta forma se vuelve al principio de la animacion
    ld h, (hl)
    ld l, a 
    jr continua_animation


;; Calcula orientacion a mover
;; INPUT IX: entidad
;; RETURN: B:orientacion
calculateAnimationOrientation:

    ld b, e_orientation(ix) ;; La anterior, por si no cambia

    ld a, e_vy(ix)
    or a 
    jr z, vyzero
vynozero:
    jp m, vynegative
vypositive: ;; down
    ld b, #o_down 
    jp vx
vynegative: ;; up
    ld b, #o_up 
    jp vx
vyzero:

vx:
    ld a, e_vx(ix)
    or a 
    jr z, vxzero
vxnozero:
    jp m, vxnegative
vxpositive: ;; right
    ld b, #o_right 
    jp endOrientation
vxnegative: ;; left
    ld b, #o_left 
    jp endOrientation
vxzero:

endOrientation:

ret


orienta_arriba:

    
    ret
